

list.paths <- function(tree, nodes = "all") {
  if (is.character(nodes)) {
    if (nodes == "terminal") {
      nodes <- nodeids(tree, terminal = TRUE)
    } else if (nodes == "inner") {
      nodes <- nodeids(tree)
      nodes <- nodes[!nodes %in% nodeids(tree, terminal = TRUE)]   
    } else if (nodes == "all") {
      nodes <- nodeids(tree)   
    }
  }
  res <- c()
  for (i in nodes) {
    res <- c(res, tail(pre:::list.rules(tree, i = i), n = 1L))
  }
  if (1L %in% nodes) {
    nodes <- nodes[-which(nodes == 1L)]
  }
  if (length(res) > 0L) {
    names(res) <- paste("node", nodes)
  }
  res
}

####################################################################
##
##  Function to extract all splitting variable and value combinations
##
list.splits <- function(paths) {
  unname(sapply(strsplit(paths, " & "), tail, n = 1L))
}

